#!/bin/sh
NAS_DB=/mnt/base/nasdb
sqlite=/opt/bin/sqlite3

if [ -z "$2" ];then
	echo "$0 dir=[dir] users=[USERS|GROUPS] anonymous=[yes|no]"
	exit 1
fi

DIR=
USERS=
ANONYMOUSE_ALLOW="no"

for VAL in $@
do
	DIR_PREFIX=${VAL:0:3}
	USERS_PREFIX=${VAL:0:5}	
	GROUPS_PREFIX=${VAL:0:6}	
	ACCESS_PREFIX=${VAL:0:6}
	ANONYMOUSE_PREFIX=${VAL:0:9}
	
	if [ "XX$DIR_PREFIX" == "XXdir" ];then
		DIR=`echo $VAL | awk -F'dir=' '{print $2}'`		
		continue
	fi
	if [ "XX$USERS_PREFIX" == "XXusers" ];then
		USERS=`echo $VAL | awk -F'users=' '{print $2}'`
		continue
	fi
	if [ "XX$ACCESS_PREFIX" == "XXaccess" ];then
		ACCESS=`echo $VAL | awk -F'access=' '{print $2}'`
		continue
	fi
	if [ "XX$ANONYMOUSE_PREFIX" == "XXanonymous" ];then
		ANONYMOUSE_ALLOW=`echo $VAL | awk -F'anonymous=' '{print $2}'`
		[ "$ANONYMOUSE_ALLOW" != "yes" ] && ANONYMOUSE_ALLOW="no"
		continue
	fi
done
echo -e "dir=$DIR\tusers=$USERS\tanonymous=$ANONYMOUSE_ALLOW"

if [ "$ACCESS" = "rw" ]; then
        ACCESS=2
elif [ "$ACCESS" == "ro" ]; then
        ACCESS=1
elif [ "$ACCESS" == "no" ];then
        ACCESS=0
fi

if [ "$DIR" == "all" ];then 
	${sqlite} $NAS_DB 'delete from acl_webdav'
	${sqlite} $NAS_DB "select folder_id from share" | while read LINE
	do
		foldername=`${sqlite} $NAS_DB "select foldername from share where folder_id=$LINE"`
		if [ ! -z "$USERS" ];then
			${sqlite} $NAS_DB "insert into acl_webdav values($LINE,'$foldername','$USERS',$ACCESS,'$ANONYMOUSE_ALLOW')"
		fi
	done	
 
else
	FOLDER_ID=`${sqlite} $NAS_DB "select FOLDER_ID from share where foldername = '$DIR'"`
	${sqlite} $NAS_DB "delete from acl_webdav where folder_id = $FOLDER_ID"
	if [ ! -z "$USERS" ];then
		${sqlite} $NAS_DB "insert into acl_webdav values($FOLDER_ID,'$DIR','$USERS',$ACCESS,'$ANONYMOUSE_ALLOW')"
	fi
fi

#Init AuthGroupFile(AuthUserFile has built when system user is add)
#STRING=`echo "$GROUPS" | awk -F'@' '{gsub("@","",$0);gsub(","," ",$0)}END{print $0}'`
AUTH_GROUP_FILE=/mnt/base/etc/.webdav.group
cat /dev/null > $AUTH_GROUP_FILE
cat /etc/group | while read line
do
	STRING=`echo $line |awk -F':' '{print $1 ":" $4}'`
	STRING=`echo $STRING | awk -F',' '{gsub(","," ",$0)}END{print $0}'`
	echo $STRING >> $AUTH_GROUP_FILE
done

#Init http-dav.conf file
/opt/sbin/svrcfg-all -c dav
#service apache2 restart

STATUS=`service apache2 status | grep "running" | grep -v grep`                                                                  
if [ "XXX${STATUS}" != "XXX"]; then                                                                                              
        service apache2 restart                                                                                                  
fi 
